
#include "bootstrap/multiboot.h"

.section ".multiboot"
   .align 4
   multiboot_header:
   /* The header itself */
      .long OSB_MULTIBOOT_HEADER_MAGIC
      .long OSB_MULTIBOOT_HEADER_FLAGS
      .long -(OSB_MULTIBOOT_HEADER_MAGIC + OSB_MULTIBOOT_HEADER_FLAGS)
      
      /* Header addr */
      .long multiboot_header

      /* Address of the begin of the loader */
      .long __load_begin
      /* Address of the end of the loader */
      .long __load_end
      /* Address of the end of the kernel */
      .long __kernel_end

      /* Goto this after the boot */
      .long multiboot_start

.text

.globl _start
_start:
multiboot_start:
   /* Creating our stack */
   movl $(stack + OSB_MULTIBOOT_STACK_SIZE), %ebp
   movl %ebp, %esp

   /* Don't ask me what is it... */
   pushl $0
   popf

   /* The two args of osb_main */
   pushl %ebx
   pushl %eax

   /* Let's go in osb himself */
   call osb_main

   /* We should never come here */
loop:
   hlt
   jmp loop

/* Our stack */
.comm stack, OSB_MULTIBOOT_STACK_SIZE

