
/* Outut format */
OUTPUT_FORMAT("elf32-i386");
OUTPUT_ARCH("i386");

/* The entry point */
ENTRY(_start);

/* The sections */
SECTIONS {
   . = 0x200000;
   __load_begin = .;

   .multiboot :{
      *(.multiboot);
      
      /* Put the section as soon as possible */
      LONG(0);
   }

   . = ALIGN(4096);
   __kernel_begin = .;

   /* This sections includes the code of the OS */
   .text ALIGN(4096) :{
      *(.text*);
   }

   .data . : {
      *(.data*);
   }

   .rodata . : {
      *(.rodata*);
   }

   __load_end = .;

   .bss SIZEOF(.rodata) + ADDR(.rodata) :{
      *(.bss*);
      *(COMMON);
   }

   __kernel_end = .;

   /* We don't want the thinks generated by GCC */
   /DISCARD/ :{
      *(.note*)
      *(.indent)
      *(.comment)
      *(.stab)
      *(.stabstr)
   }
}
