#! /bin/bash

img_name=$1
kernel_name=$2
grub_dir=/lib/grub/i386-pc

# mtools config
export MTOOLSRC=mtoolsrc
rm -f $MTOOLSRC
echo "drive u: file=\"$img_name\" 1.44M filter" > $MTOOLSRC

# Formatting
mformat u:

# Layout
mmd u:/boot
mmd u:/boot/grub

# Grub copy
mcopy $grub_dir/stage1 u:/boot/grub/
mcopy $grub_dir/stage2 u:/boot/grub/

# Grub config
rm -f menu.txt
cat <<EOF > menu.txt
timeout 5
default 0
title  OSB (OS Bidouilles)
root   (fd0)
kernel /boot/`basename $kernel_name`
EOF
mcopy -bo menu.txt u:/boot/grub/

# Grub install
/sbin/grub >/dev/null 2>&1 --batch <<EOL
   device (fd0) $img_name
   install (fd0)/boot/grub/stage1 (fd0) (fd0)/boot/grub/stage2 p \
      (fd0)/boot/grub/menu.txt
   quit
EOL

# Kernel copy
mcopy $kernel_name u:/boot/

# Cleaning
rm -f $MTOOLSRC
rm -f menu.txt
